/*
           Kostky - Obdoba hry tetris                    
           Copyright (C) 2002  Pavel Matouek                                     
                                                                                
           Tento program je voln programov vybaven; mete jej it a       
       modifikovat podle ustanoven Obecn veejn licence GNU, vydvan Free   
       Software Foundation; a to bu verze 2 tto licence anebo (podle vaeho   
       uven) kterkoli pozdj verze.                                       
                                                                                
           Tento program je roziovn v nadji, e bude uiten, avak BEZ    
       JAKKOLI ZRUKY; neposkytuj se ani odvozen zruky PRODEJNOSTI anebo    
       VHODNOSTI PRO URIT EL.                                               
       Dal podrobnosti hledejte v Obecn veejn licenci GNU.                 
                                                                                
          Kopii Obecn veejn licence GNU jste ml obdret spolu s tmto       
       programem; pokud se tak nestalo, napite o ni Free Software Foundation,  
       Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                            

	Posledni zmena: 18.02.2002
	Kontakt: pavelmmm@seznam.cz
	Vyrobeno pro fiktivni firmu MAX Corporation www.maxcorp.zde.cz nebo www.maxcorp.zde.cz/en	
	Uplne zneni licence v ceskem jazyce naleznete na adrese: www.maxcorp.zde.cz/wcopying_cs.txt












 *********************************************
 * Kostky - Logicka 2D hra                   *
 * Programator - Pavel Matousek (Max)-Leader *
 * URL: http://www.maxcorp.zde.cz            *
 * Zacatek - 31.12.2001                      *
 * Konec - 18.02.2002                        *
 * Verze - 0.60 - oficialne 1.00             *
 *                                           *
 * Dalsi poznamky:                           *
 *                                           *
 * - od verze 0.11 se zacina delat na menu   *
 *   a grafickym enginu                      *
 *                                           *
 * - od verze 0.21 pridana nova pisma        *
 *                                           *
 * - uz je i tabulka vyhercu ve ver. 0.23    *
 *                                           *
 * - 0.25 pridany barevne kostky             *
 *                                           *
 * - 0.30 uvodni animace uz je na svete      *
 *                                           *
 * - 0.31 autors uz je taky ok               *
 *                                           *
 * - 0.32 pridana hudba                      *
 *                                           *
 * - 0.35 pridana hudba MP3 podle libosti    *
 *                                           *
 * - 0.45 predelani na datovy soubor         *
 *                                           *
 * - 0.55 dana pryc MPtrojka vlastni         *
 *                                           *
 * - uz se v tom zacinam ztracet, ale pohoda *
 *                                           *
 * - po roce Linuxovy port                   *
 *                                           *
 *********************************************
*/

#include <stdio.h>
//#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "allegro.h" // hlav.soubor allegra
#include "kostky.h"  // datovy soubor kostky.dat
// #include "almp3.h"  // na prehravani MP3


// definice

// rozmery hraciho pole
#define HRACI_POLE_X 10
#define HRACI_POLE_Y 20

// netreba popisovat
#define POCATECNI_RYCHLOST 30

// BackBuffer
#define BB BackBuffer

// definice obrazoveho modu
#define COLOR_DEPTH15 15
#define COLOR_DEPTH16 16
#define COLOR_DEPTH24 24
#define COLOR_DEPTH32 32

#define SCREEN_CX 640
#define SCREEN_CY 480

// klvesnice
#define DELAY_KLAV 2

// level up - pocateni hodnota 5000
#define LEVELUP 1000

// pro MP3
#define DATASZ  (1<<17) /* (32768*4) amount of data to read from disk each time */
#define BUFSZ   (1<<17) /* (65536*2) size of audiostream buffer */


// struktury

// struktura hrace v tabulce
typedef struct NEJLEPSI
{
	char Jmeno[11];
	int Score;
} NEJLEPSI;

// animace kostky na obr.
typedef struct ANIMKOSTKA
{
	int x;
	int y;
	int sx;
	int sy;
	int JeVidet;
	int JakDlouho;
	int Barva;

} ANIMKOSTKA;

// MP3 File
typedef struct {
  PACKFILE *f;
//  MP3STREAM *s;
} MP3FILE;

// promenne

// promenne pro grafuku a allegro a cesty k souborum
PALETTE Pal;
BITMAP *BackBuffer;
BITMAP *Kostka[7];
BITMAP *MenuPolozky[6];
BITMAP *Koule[1];
BITMAP *UvodObr;
/*
0-9			= 0-9
10-35		= A-Z
36-61		= a-z
62			= =
63			= ,
64			= :
65			= .
66			= /
67			= (
68			= )
*/
BITMAP *Fonty[75];

// cesty 
// teoreticky diky datovemu souboru uz nejsou potreba, ale necham je tu.
// pamet rolik neyabiraji a muzou se casem pri predelavce hodit.
char PathKostka1[]=		"./data/kostka1.bmp";
char PathKostka2[]=		"./data/kostka2.bmp";
char PathKostka3[]=		"./data/kostka3.bmp";
char PathKostka4[]=		"./data/kostka4.bmp";
char PathKostka5[]=		"./data/kostka5.bmp";
char PathKostka6[]=		"./data/kostka6.bmp";
char PathKostka7[]=		"./data/kostka7.bmp";
char PathUvod[]=		"./data/uvod.bmp";
char PathAutors[]=		"./data/autors.bmp";
char PathKonec[]=		"./data/konec.bmp";
char PathNovaHra[]=		"./data/novahra.bmp";
char PathNejlepsi[]=	"./data/nejlepsi.bmp";
char PathHudbaOn[]=		"./data/h-on.bmp";
char PathHudbaOff[]=	"./data/h-off.bmp";
char PathKoule[]=		"./data/koule.bmp";

// zvuk
char PathHudbaMP3[]=			"./data/sounds/hudba.mp3";
char PathRadaMP3[]=				"./data/sounds/rada.mp3";
char PathHudbaWAV[]=			"./data/sounds/hudba.wav";
char PathRadaWAV[]=				"./data/sounds/rada.wav";
char PathMP3File[128] =			"";
char PathKostkyDatSoubor[] =	"kostky.dat";

// hudba
int zvVolume = 255;
int zvRychlost = 300;

SAMPLE *snRada;

// MP3
// MP3FILE *MP3File;
int MP3Play = FALSE;
int HUDBA = TRUE;
int SOUND = TRUE;

// datovy soubor
DATAFILE *datafile;

// promenne pro menu
int MenuAktive = 0, OldMenuAktive = 1;

// promenne pro hru

// promena pro nejlepsi score
NEJLEPSI Nejlepsi[5];

// anim kostky
ANIMKOSTKA AnimKostka[14];

// level kola
int Level, LevelUp;

// pocita score hrace + Jmeno hrace kvuli tabulce vyhercu
int Score;
char Jmeno[11];

// hraci plocha na ktere jsou kostky
int HraciPole[20][10];

// sirka a vyska aktualni kostky
int Sirka, Vyska, OldSirka, OldVyska, DalsiSirka, DalsiVyska;

// stav letici kostky
int Otoceni, MuzeOtocit, KteraKostka, OldOtoceni, OldKteraKostka,
    DalsiOtoceni, DalsiKteraKostka;

// barva kostky
int Barva, OldBarva, DalsiBarva;

// casovac ktery se vola pomoci preruseni
volatile int Timer, InputKlav; 

// na delay klavesnice
int KlavBuf[3] = {0, 0, 0}, OldInputKlav;

// jestli se ma ukoncit hra nebo program
int Konec = 0, Exit = 0;

// rychlost padajici kostky, standardne bude 20 (mozna 25) a pak ubirat se bude
int Rychlost = POCATECNI_RYCHLOST, NormalniRychlost = POCATECNI_RYCHLOST;

// kde se pohybuje kostka v poli
int X, Y, OldX, OldY;


// rozhoduje o prekresleni obrazovky
int Prekreslit = 1;


// definice kostek vcetne otoceni
int Kostky[6][4][4][4] = {
	{ // 0
		{
			{1,1,1,1},
			{0,0,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,0,0,0},
			{1,0,0,0},
			{1,0,0,0},
			{1,0,0,0}
		},
		{
			{1,1,1,1},
			{0,0,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,0,0,0},
			{1,0,0,0},
			{1,0,0,0},
			{1,0,0,0}
		}
	},
	{ // 1
		{
			{1,0,0,0},
			{1,1,0,0},
			{0,1,0,0},
			{0,0,0,0}
		},
		{
			{0,1,1,0},
			{1,1,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,0,0,0},
			{1,1,0,0},
			{0,1,0,0},
			{0,0,0,0}
		},
		{
			{0,1,1,0},
			{1,1,0,0},
			{0,0,0,0},
			{0,0,0,0}
		}
	},
	{ // 2
		{
			{0,1,0,0},
			{1,1,0,0},
			{1,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{0,1,1,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{0,1,0,0},
			{1,1,0,0},
			{1,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{0,1,1,0},
			{0,0,0,0},
			{0,0,0,0}
		}
	},
	{ // 3
		{
			{1,1,1,0},
			{1,0,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{0,1,0,0},
			{0,1,0,0},
			{0,0,0,0}
		},
		{
			{0,0,1,0},
			{1,1,1,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,0,0,0},
			{1,0,0,0},
			{1,1,0,0},
			{0,0,0,0}
		}
	},
	{ // 4
		{
			{1,1,1,0},
			{0,0,1,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{0,1,0,0},
			{0,1,0,0},
			{1,1,0,0},
			{0,0,0,0}
		},
		{
			{1,0,0,0},
			{1,1,1,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{1,0,0,0},
			{1,0,0,0},
			{0,0,0,0}
		}
	},
	{ // 5
		{
			{1,1,0,0},
			{1,1,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{1,1,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{1,1,0,0},
			{0,0,0,0},
			{0,0,0,0}
		},
		{
			{1,1,0,0},
			{1,1,0,0},
			{0,0,0,0},
			{0,0,0,0}
		}
	}

};

char szAutors[49][40]={"Kostky v. 1.0",
                     "",
					 "",
					 "Programovani",
					 "",
					 "Pavel Matousek (Max)",
					 "http://www.matousek.zde.cz",
					 "",
					 "",
					 "Grafika ",
					 "",
					 "Zdenek Trubka (Picket)",
					 "",
					 "",
					 "Zvuk",
					 "",
					 "Michal Pullmann (Micca)",
					 "",
					 "",
					 "Linux Port",
					 "",
					 "Bernard Lidicky",
					 "",
					 "",
					 "Testovali",
					 "",
					 "Pavel Matousek (Max)",
					 "",
					 "Zdenek Trubka (Picket)",
					 "",
					 "",
					 "Vyrobilo",
					 "",
					 "2002, 2003 MAX Corporation",
					 "http://www.maxcorp.zde.cz",
					 "",
                "2003 Hippo Games",
                "http://www.hippo.nipax.cz",
					 "",
					 "Special thanks",
					 "",
					 "DJ Delorie za DJGPP",
					 "http://www.delorie.com",
					 "",
					 "Shawn Hargreaves za Allegro",
					 "http://www.talula.demon.co.uk/allegro/",
					 "",
					 "",
					 "Alexev Pajitnov za originalni myslenku"};





// nektere funkci prototypy, abych nemusel davat definici funkce nad tu, ve ktery ji volam
void KontrolujRadky(void);
void CekejNaStiskESC(void);
void KonecProgramu(void);
int RandomInt(int n);
void KresliGrafKostku(int BarvaKostky, int X, int Y);


// F U N K C E


// funkce pro MP3 - V Linuxu nebezi
// prevzato z prikladu k AllegroMP3
/*
MP3FILE *open_mp3_file(char *filename) {
  MP3FILE *p = NULL;
  PACKFILE *f = NULL;
  MP3STREAM *s = NULL;
  char data[DATASZ];
  int len;

  if (!(p = (MP3FILE *)malloc(sizeof(MP3FILE))))
    goto error;
  if (!(f = pack_fopen(filename, F_READ)))
    goto error;
  if ((len = pack_fread(data, DATASZ, f)) <= 0)
    goto error;
  if (len < DATASZ) {
    if (!(s = create_mp3stream(data, len, TRUE)))
      goto error;
  }
  else {
    if (!(s = create_mp3stream(data, DATASZ, FALSE)))
      goto error;
  }
  p->f = f;
  p->s = s;
  return p;

  error:
  pack_fclose(f);
  free(p);
  return NULL;
}

*/
/*
int play_mp3_file(MP3FILE *mp3, int buflen, int vol, int pan) {
  return 1; //play_mp3stream(mp3->s, buflen, vol, pan);
}
*/

void close_mp3_file(MP3FILE *mp3) {
 /* if (mp3) {
    pack_fclose(mp3->f);
    destroy_mp3stream(mp3->s);
    free(mp3);
  }
*/
}


int poll_mp3_file(MP3FILE *mp3) {
/*  char *data;
  long len;

  data = (char *)get_mp3stream_buffer(mp3->s);
  if (data) {
    len = pack_fread(data, DATASZ, mp3->f);
    if (len < DATASZ)
      free_mp3stream_buffer(mp3->s, len);
    else
      free_mp3stream_buffer(mp3->s, -1);
  }

  return poll_mp3stream(mp3->s);
*/
}
// konec AllegroMP3


// funkce pro grafiku v allegru

//---------------------------------------
// Name: FlipToScreen()
// Dest: Prerenderuje BackBuffer na obrazovku
//---------------------------------------
void FlipToScreen(void)
{
  blit(BB, screen, 0,0,0,0,SCREEN_W,SCREEN_H);
}

//---------------------------------------
// Name: Anim()
// Dest: Uvod. anim.
//---------------------------------------
void Anim(void)
{
//  blit(BB, screen, 0,0,0,0,SCREEN_W,SCREEN_H);
	int x=0,y=480;
	ANIMKOSTKA akKostky[14];
	int i = 0, ii=0;

    memset(akKostky, 0, sizeof(ANIMKOSTKA)*14);

	for (i=0;i<14;i++)
	{
		akKostky[i].JeVidet=1;
		akKostky[i].x=RandomInt(600)+20;
		akKostky[i].y=RandomInt(440)+20;
		akKostky[i].sx=RandomInt(10)-5;
		akKostky[i].sy=RandomInt(10)-5;
		
		if (akKostky[i].sx == 0|| akKostky[i].sy == 0)
		{
			akKostky[i].sx = 1;
			akKostky[i].sy = 1;
		}

		akKostky[i].JakDlouho=20;
		akKostky[i].Barva=RandomInt(7);

	}

	
	while (x<=640)
	{
		clear(BB);

		//horni
		blit(UvodObr, BB, 640-x, 0,0, 0, 640, 240);
		//dolni
		blit(UvodObr, BB, 0, 240,640-x, 240, x, 480);
		rest(10);
		x+=10;

		FlipToScreen();
	}

//	rest(1000);

	clear_keybuf();

	while (1)
	{
		for (i=0;i<14;i++)
		{
			akKostky[i].x += akKostky[i].sx;
 			akKostky[i].y += akKostky[i].sy;

			if (akKostky[i].x < 0)
			{
				akKostky[i].x = 0;
				akKostky[i].sx = RandomInt(5) + 1;
	     		akKostky[i].Barva=RandomInt(7);
			}

			if (akKostky[i].x > 620)
			{
				akKostky[i].x = 620;
				akKostky[i].sx = RandomInt(5) - 5;
	     		akKostky[i].Barva=RandomInt(7);
			}

			if (akKostky[i].y < 0)
			{
				akKostky[i].y = 0;
				akKostky[i].sy = RandomInt(5) + 1;
	     		akKostky[i].Barva=RandomInt(7);
			}

			if (akKostky[i].y > 460)
			{
				akKostky[i].y = 460;
				akKostky[i].sy = RandomInt(5) - 5;
	     		akKostky[i].Barva=RandomInt(7);
			}
		}

		// render scene
		clear(BB);
		blit(UvodObr, BB, 0, 0,0, 0, 640, 480);
		
		for(i=0;i<14;i++)
		{
			KresliGrafKostku(akKostky[i].Barva, akKostky[i].x, akKostky[i].y);
		}			

		FlipToScreen();
		// konec render

		if (key[KEY_SPACE] || key[KEY_ESC] || key[KEY_ENTER])
			break;

		rest(25);
	}	
	
	clear_keybuf();
	
	while (y>=0)
	{
		clear(BB);

		// cela
		blit(UvodObr, BB, 0, 480-y,0, 0, 640, 480);

		rest(25);
		y-=10;

		FlipToScreen();
	}


}

//---------------------------------------
// Name: KresliGrafKostku()
// Dest: vykresli kostku
//---------------------------------------
void KresliGrafKostku(int BarvaKostky, int X, int Y)
{
  blit(Kostka[BarvaKostky], BB, 0,0,X,Y, Kostka[BarvaKostky]->w, Kostka[BarvaKostky]->h);
//  blit(Kostka[Barva], BB, 0,0,X,Y, 20, 20);
}


// funkce pro hru

//---------------------------------------
// Name: Chyba()
// Dest: Okamzite ukonci program s chybovim hlasenim
//---------------------------------------
void Chyba(const char *p_Str)
{
//	allegro_exit();
    clear(screen);
	textprintf(screen, font, 10, 10, makecol(255, 0, 0), "Chyba: %s - Press Key...", p_Str);
//	printf("Chyba: %s\n\r\n\rPress Key...", p_Str);
	clear_keybuf();
	readkey();
	exit(0);
}


//---------------------------------------
// Name: IntTimer()
// Dest: Casovac ktery inkrementuje pomoci preruseni promenou Timer
//---------------------------------------
void IntTimer(void)
{
	Timer++;
}
END_OF_FUNCTION(IntTimer);
		
//---------------------------------------
// Name: IntInput()
// Dest: Casovac ktery inkrementuje pomoci preruseni promenou InputKlav
//---------------------------------------
void IntInput(void)
{
	InputKlav++;
}
END_OF_FUNCTION(IntInput);

//---------------------------------------
// Name: InitHraciPole()
// Dest: Inicializuje hraci pole aby bylo ciste pred zacatkem hry
//---------------------------------------
void InitHraciPole(void)
{
	int i,j;

	for (i=0; i<HRACI_POLE_Y; i++) 
	{
		for (j=0; j<HRACI_POLE_X; j++)
		{
			HraciPole[i][j] = -1;
		}
	}
}

//---------------------------------------
// Name: RozmeryKostky()
// Dest: Vrati rozmery kostky - sirka a vyska
//---------------------------------------
void RozmeryKostky(int *Sirka, int *Vyska, int KteraKostka, int Otoceni)
{
	switch(KteraKostka)
	{
	case 0: if (Otoceni == 0 || Otoceni == 2) 
			{
				*Sirka = 4;
				*Vyska = 1;
			}
		    else
			{
				*Sirka = 1;
				*Vyska = 4;
			}
			break;
	
	case 1: if (Otoceni == 0 || Otoceni == 2) 
			{
				*Sirka = 2;
				*Vyska = 3;
			}
		    else
			{
				*Sirka = 3;
				*Vyska = 2;
			}
			break;
		
	case 2: if (Otoceni == 0 || Otoceni == 2) 
			{
				*Sirka = 2;
				*Vyska = 3;
			}
		    else
			{
				*Sirka = 3;
				*Vyska = 2;
			}
			break;
		
	case 3: if (Otoceni == 0 || Otoceni == 2) 
			{
				*Sirka = 3;
				*Vyska = 2;
			}
		    else
			{
				*Sirka = 2;
				*Vyska = 3;
			}
			break;
		
	case 4: if (Otoceni == 0 || Otoceni == 2) 
			{
				*Sirka = 3;
				*Vyska = 2;
			}
		    else
			{
				*Sirka = 2;
				*Vyska = 3;
			}
			break;
		
	case 5: if (Otoceni == 0 || Otoceni == 2) 
			{
				*Sirka = 2;
				*Vyska = 2;
			}
		    else
			{
				*Sirka = 2;
				*Vyska = 2;
			}
			break;
	}
}


//---------------------------------------
// Name: KresliHraciPole()
// Dest: vykresli aktualni stav kostek v hracim poli
//---------------------------------------
void KresliHraciPole(void)
{
	int i,j,k=0;

//	printf("###############\n\r");

	for (i=0; i<HRACI_POLE_Y; i++) 
	{
//       	printf("%2d #", k++);
		for (j=0; j<HRACI_POLE_X; j++)
		{
			
			if (HraciPole[i][j] != -1)
					KresliGrafKostku(HraciPole[i][j], j*20+220 , i*20+40);
//			else
//				printf(" ");


		}
//		printf("#");
//		printf("\n\r");
	}

//	printf("###############\n\r");
}

//---------------------------------------
// Name: InitGame()
// Dest: Vsechno inicializuje
//---------------------------------------
int InitGame(void)
{
	int Result, i;
//	char s[64], c;

//	clrscr();

	InitHraciPole();

	allegro_init();
    install_timer();
    install_keyboard();

	// nahodi grafiku
	//
	//  Kdoz chce hrat v okne, necht zameni GFX_AUTODETECT za GFX_AUTODETECT_WINDOWED
	// 
	set_color_depth(COLOR_DEPTH16);
	Result = set_gfx_mode(GFX_AUTODETECT, SCREEN_CX, SCREEN_CY, 0, 0);

	// testuje uspesnost
	if (Result<0)
	{
		set_color_depth(COLOR_DEPTH24);
		Result = set_gfx_mode(GFX_AUTODETECT, SCREEN_CX, SCREEN_CY, 0, 0);
		if (Result<0)
		{
			set_color_depth(COLOR_DEPTH32);
			Result = set_gfx_mode(GFX_AUTODETECT, SCREEN_CX, SCREEN_CY, 0, 0);
			if (Result<0)
			{
				set_color_depth(COLOR_DEPTH15);
				Result = set_gfx_mode(GFX_AUTODETECT, SCREEN_CX, SCREEN_CY, 0, 0);
				if (Result<0)
				{
					Chyba("Nejde Grafika");
					readkey();
				}
			}
		}
	}

//	Chyba("KUK");

	
	datafile = load_datafile(PathKostkyDatSoubor);
	if (!datafile) 
	{
		Chyba("DATAFILE");

	}
	if (HUDBA == TRUE && SOUND == TRUE)
	{
		set_volume_per_voice(0);

		if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0)
		{
			
			//Chyba("Install sound");
			MP3Play = FALSE;
			HUDBA = FALSE;
			SOUND = FALSE;
		}
		else
		{

//			snRada = load_sample(PathRadaWAV);
			snRada = (SAMPLE *)datafile[RADA].dat;


			if (!snRada)
			{
				Chyba("NAcitani zvuku rady");
			}
		}
	}



	BB = create_bitmap(SCREEN_CX, SCREEN_CY);
  
	clear(BB);

//	UvodObr = load_bitmap(PathUvod, Pal);
	UvodObr = (BITMAP *)datafile[UVOD_BMP].dat;

    if (!UvodObr)
      Chyba("Nacitani UvodObr");
 
//	Koule[0] = load_bitmap(PathKoule, Pal);
	Koule[0] = (BITMAP *)datafile[KOULE_BMP].dat;

    if (!Koule[0])
      Chyba("Nacitani Koule");

/*	
	Kostka[0] = load_bitmap(PathKostka1, Pal);
	Kostka[1] = load_bitmap(PathKostka2, Pal);
	Kostka[2] = load_bitmap(PathKostka3, Pal);
	Kostka[3] = load_bitmap(PathKostka4, Pal);
	Kostka[4] = load_bitmap(PathKostka5, Pal);
	Kostka[5] = load_bitmap(PathKostka6, Pal);
	Kostka[6] = load_bitmap(PathKostka7, Pal);
*/
	Kostka[0] = (BITMAP *)datafile[KOSTKA_1].dat;
	Kostka[1] = (BITMAP *)datafile[KOSTKA_2].dat;
	Kostka[2] = (BITMAP *)datafile[KOSTKA_3].dat;
	Kostka[3] = (BITMAP *)datafile[KOSTKA_4].dat;
	Kostka[4] = (BITMAP *)datafile[KOSTKA_5].dat;
	Kostka[5] = (BITMAP *)datafile[KOSTKA_6].dat;
	Kostka[6] = (BITMAP *)datafile[KOSTKA_7].dat;

    
	for(i=0;i<7;i++)
	  if (!Kostka[i])
        Chyba("Nacitani kostky");

/*
	MenuPolozky[0] = load_bitmap(PathNovaHra, Pal);
	MenuPolozky[1] = load_bitmap(PathHudbaOn, Pal);
	MenuPolozky[2] = load_bitmap(PathNejlepsi, Pal);
	MenuPolozky[3] = load_bitmap(PathAutors, Pal);
	MenuPolozky[4] = load_bitmap(PathKonec, Pal);
	MenuPolozky[5] = load_bitmap(PathHudbaOff, Pal);
*/
	MenuPolozky[0] = (BITMAP *)datafile[NOVA_HRA_BMP].dat;
	MenuPolozky[1] = (BITMAP *)datafile[HUDBA_ON].dat;
	MenuPolozky[2] = (BITMAP *)datafile[NEJLEPSI_BMP].dat;
	MenuPolozky[3] = (BITMAP *)datafile[AUTORS_BMP].dat;
	MenuPolozky[4] = (BITMAP *)datafile[KONEC_BMP].dat;
	MenuPolozky[5] = (BITMAP *)datafile[HUDBA_OFF].dat;


	for (i=0;i<6;i++)
		if (!MenuPolozky[i])
			Chyba("Nacitani Menu Polozky");

	// nacte fonty
/*
0-9			= 0-9
10-35		= A-Z
36-61		= a-z
62			= =
63			= ,
64			= :
65			= .
66			= /
67			= (
68			= )
*/

	
	Fonty[0] = (BITMAP *)datafile[CISLO_0].dat;
	Fonty[1] = (BITMAP *)datafile[CISLO_1].dat;
	Fonty[2] = (BITMAP *)datafile[CISLO_2].dat;
	Fonty[3] = (BITMAP *)datafile[CISLO_3].dat;
	Fonty[4] = (BITMAP *)datafile[CISLO_4].dat;
	Fonty[5] = (BITMAP *)datafile[CISLO_5].dat;
	Fonty[6] = (BITMAP *)datafile[CISLO_6].dat;
	Fonty[7] = (BITMAP *)datafile[CISLO_7].dat;
	Fonty[8] = (BITMAP *)datafile[CISLO_8].dat;
	Fonty[9] = (BITMAP *)datafile[CISLO_9].dat;
		
		
	for (i=0;i<10;i++)
	{
//		strcpy(s, "");
//		sprintf(s,"./data/fonts/%d.bmp", i);
//		Fonty[i] = load_bitmap(s, Pal);

		if (!Fonty[i])
			Chyba("Chyba pri nacitani FONTU");
	}

	// velky

	Fonty[10] = (BITMAP *)datafile[VELKY_A].dat;
	Fonty[11] = (BITMAP *)datafile[VELKY_B].dat;
	Fonty[12] = (BITMAP *)datafile[VELKY_C].dat;
	Fonty[13] = (BITMAP *)datafile[VELKY_D].dat;
	Fonty[14] = (BITMAP *)datafile[VELKY_E].dat;
	Fonty[15] = (BITMAP *)datafile[VELKY_F].dat;
	Fonty[16] = (BITMAP *)datafile[VELKY_G].dat;
	Fonty[17] = (BITMAP *)datafile[VELKY_H].dat;
	Fonty[18] = (BITMAP *)datafile[VELKY_I].dat;
	Fonty[19] = (BITMAP *)datafile[VELKY_J].dat;
	Fonty[20] = (BITMAP *)datafile[VELKY_K].dat;
	Fonty[21] = (BITMAP *)datafile[VELKY_L].dat;
	Fonty[22] = (BITMAP *)datafile[VELKY_M].dat;
	Fonty[23] = (BITMAP *)datafile[VELKY_N].dat;
	Fonty[24] = (BITMAP *)datafile[VELKY_O].dat;
	Fonty[25] = (BITMAP *)datafile[VELKY_P].dat;
	Fonty[26] = (BITMAP *)datafile[VELKY_Q].dat;
	Fonty[27] = (BITMAP *)datafile[VELKY_R].dat;
	Fonty[28] = (BITMAP *)datafile[VELKY_S].dat;
	Fonty[29] = (BITMAP *)datafile[VELKY_T].dat;
	Fonty[30] = (BITMAP *)datafile[VELKY_U].dat;
	Fonty[31] = (BITMAP *)datafile[VELKY_V].dat;
	Fonty[32] = (BITMAP *)datafile[VELKY_W].dat;
	Fonty[33] = (BITMAP *)datafile[VELKY_X].dat;
	Fonty[34] = (BITMAP *)datafile[VELKY_Y].dat;
	Fonty[35] = (BITMAP *)datafile[VELKY_Z].dat;
	
	
	
	
	
	
//	c = 'a';

	for (i=10;i<36;i++)
	{
//		strcpy(s, "");
//		sprintf(s,"./data/fonts/%c.bmp", c);
//		Fonty[i] = load_bitmap(s, Pal);

		if (!Fonty[i])
			Chyba("Chyba pri nacitani FONTU");
		// inkrementuje pismeno v abecede - pro nacitani
//		c++;
	}

	// maly

	Fonty[36] = (BITMAP *)datafile[MALY_a].dat;
	Fonty[37] = (BITMAP *)datafile[MALY_b].dat;
	Fonty[38] = (BITMAP *)datafile[MALY_c].dat;
	Fonty[39] = (BITMAP *)datafile[MALY_d].dat;
	Fonty[40] = (BITMAP *)datafile[MALY_e].dat;
	Fonty[41] = (BITMAP *)datafile[MALY_f].dat;
	Fonty[42] = (BITMAP *)datafile[MALY_g].dat;
	Fonty[43] = (BITMAP *)datafile[MALY_h].dat;
	Fonty[44] = (BITMAP *)datafile[MALY_i].dat;
	Fonty[45] = (BITMAP *)datafile[MALY_j].dat;
	Fonty[46] = (BITMAP *)datafile[MALY_k].dat;
	Fonty[47] = (BITMAP *)datafile[MALY_l].dat;
	Fonty[48] = (BITMAP *)datafile[MALY_m].dat;
	Fonty[49] = (BITMAP *)datafile[MALY_n].dat;
	Fonty[50] = (BITMAP *)datafile[MALY_o].dat;
	Fonty[51] = (BITMAP *)datafile[MALY_p].dat;
	Fonty[52] = (BITMAP *)datafile[MALY_q].dat;
	Fonty[53] = (BITMAP *)datafile[MALY_r].dat;
	Fonty[54] = (BITMAP *)datafile[MALY_s].dat;
	Fonty[55] = (BITMAP *)datafile[MALY_t].dat;
	Fonty[56] = (BITMAP *)datafile[MALY_u].dat;
	Fonty[57] = (BITMAP *)datafile[MALY_v].dat;
	Fonty[58] = (BITMAP *)datafile[MALY_w].dat;
	Fonty[59] = (BITMAP *)datafile[MALY_x].dat;
	Fonty[60] = (BITMAP *)datafile[MALY_y].dat;
	Fonty[61] = (BITMAP *)datafile[MALY_z].dat;
	
	
//	c = 'a';

	for (i=36;i<62;i++)
	{
//		strcpy(s, "");
//		sprintf(s,"./data/fonts/m%c.bmp", c);
//		Fonty[i] = load_bitmap(s, Pal);

		if (!Fonty[i])
			Chyba("Chyba pri nacitani FONTU");
		// inkrementuje pismeno v abecede - pro nacitani
//		c++;
	}

//	Fonty[62] = load_bitmap("./data/fonts/rovnase.bmp", Pal);
	Fonty[62] = (BITMAP *)datafile[ROVNA_SE].dat;
	if (!Fonty[62])
		Chyba("Chyba pri nacitani FONTU");

//	Fonty[63] = load_bitmap("./data/fonts/carka.bmp", Pal);
	Fonty[63] = (BITMAP *)datafile[CARKA].dat;
	if (!Fonty[63])
		Chyba("Chyba pri nacitani FONTU");

//	Fonty[64] = load_bitmap("./data/fonts/dvojtec.bmp", Pal);
	Fonty[64] = (BITMAP *)datafile[DVOJTECKA].dat;
	if (!Fonty[64])
		Chyba("Chyba pri nacitani FONTU");
    
//	Fonty[65] = load_bitmap("./data/fonts/tecka.bmp", Pal);
	Fonty[65] = (BITMAP *)datafile[TECKA].dat;
	if (!Fonty[65])
		Chyba("Chyba pri nacitani FONTU");	
	
//	Fonty[66] = load_bitmap("./data/fonts/lom.bmp", Pal);
	Fonty[66] = (BITMAP *)datafile[LOMITKO].dat;
	if (!Fonty[66])
		Chyba("Chyba pri nacitani FONTU");	
	
//	Fonty[67] = load_bitmap("./data/fonts/zav-o.bmp", Pal);
	Fonty[67] = (BITMAP *)datafile[ZAVORKA_LEVA].dat;
	if (!Fonty[67])
		Chyba("Chyba pri nacitani FONTU");	

//	Fonty[68] = load_bitmap("./data/fonts/zav-z.bmp", Pal);
	Fonty[68] = (BITMAP *)datafile[ZAVORKA_PRAVA].dat;
	if (!Fonty[68])
		Chyba("Chyba pri nacitani FONTU");	

	// aby to bylo vice randomize, ale moc mi to nefunguje prozatim
//    srandom((int) time(NULL));

    // zapne a zamkne IntTimer a Timer a nastavi na 20 ms casovac
    LOCK_VARIABLE(Timer);
    LOCK_FUNCTION(IntTimer);
    install_int(IntTimer, 20);

    // zapne a zamkne IntInput a InputKlav a nastavi na 20 ms casovac
    LOCK_VARIABLE(InputKlav);
    LOCK_FUNCTION(IntInput);
    install_int(IntInput, 100);

	return 1;
}

//---------------------------------------
// Name: UnInitGame()
// Dest: Vsechno odinicializuje
//---------------------------------------
void UnInitGame(void)
{
	unload_datafile(datafile);
//	allegro_exit();
//  set_gfx_mode(GFX_TEXT, 80, 25, 0, 0);
}

//---------------------------------------
// Name: RandomInt()
// Dest: Vrati cele cislo od 0 do n-1
//---------------------------------------
int RandomInt(int n)
{
	return (rand() % n);
}

//---------------------------------------
// Name: VypisText()
// Dest: Vypise text
//---------------------------------------
void VypisText(const char *s, int x, int y, int barva)
{
	textout(BB, font, s, x, y, barva);
}

//---------------------------------------
// Name: VypisTextGraficky()
// Dest: Vypise text v grafice
//---------------------------------------
void VypisTextGraficky(const char *s, int x, int y)
{
	int i, sirka=0, ktery;
 
	if (!s)
		return;
	
	for (i=0; i<(int)strlen(s);i++)
	{
		if (s[i] >= '0' && s[i] <= '9')
		{
			ktery = ((int) s[i]) - 48;
		}

		if (s[i] >= 'a' && s[i] <= 'z')
		{
			ktery = ((int) s[i]) - 61;
		}

		if (s[i] >= 'A' && s[i] <= 'Z')
		{
			ktery = ((int) s[i]) - 55;
		}

		
		if (s[i] == '=')
		{
			ktery = 62;
		}

		if (s[i] == ',')
		{
			ktery = 63;
		}
		
		if (s[i] == ':')
		{
			ktery = 64;
		}

		if (s[i] == '.')
		{
			ktery = 65;
		}

		if (s[i] == '/')
		{
			ktery = 66;
		}

		if (s[i] == '(')
		{
			ktery = 67;
		}

		if (s[i] == ')')
		{
			ktery = 68;
		}

		if (s[i] == ' ')
		{
			sirka += 5;
			continue;
		}	
		

		masked_blit(Fonty[ktery], BB, 0, 0, x+sirka, y, Fonty[ktery]->w, Fonty[ktery]->h);
		sirka += Fonty[ktery]->w;

	}
}


//---------------------------------------
// Name: KresliDalsiKostku()
// Dest: vzklresli policko s dalsi kostkou
//---------------------------------------
void KresliDalsiKostku(void)
{
	int i, j;

	for(i=0;i<15;i++)
		rect(BB, 458-i, 249-i, 540+i, 330+i, makecol(70+i*8, 70+i*8, 70+i*8) );

	for (i=0; i<DalsiVyska; i++) 
	{
		for (j=0; j<DalsiSirka; j++)
		{
			if (Kostky[DalsiKteraKostka][DalsiOtoceni][i][j] == 1)
					KresliGrafKostku(DalsiBarva, j*20+460 , i*20+250);
		}
	}

}


	//---------------------------------------
// Name: RenderScene()
// Dest: Vykresli celou scenu
//---------------------------------------
void RenderScene(void)
{
	int i, x = 0;
	
	// pomocna pro vypis funkce vypistextgraficky();
	char s[128];

	
	// smazu minulou scenu v BB
	clear(BB);
	
	// kresli veci okolo
	for(i=0;i<15;i++)
		rect(BB, 218-i, 39-i, 420+i, 440+i, makecol(70+i*8, 70+i*8, 70+i*8) );

	// kresli samotne kostky
	KresliHraciPole();

	KresliDalsiKostku();


	// kresli Score a pripadne dalsi texty
	sprintf(s,"Score = %d", Score);
   	VypisTextGraficky(s, 450, 100);
	sprintf(s,"Level = %d", Level);
 	VypisTextGraficky(s, 450, 120);

	
	VypisText(" - = O V L A D A N I = -", 10, 100, makecol(80, 80, 80));

	VypisText("Sipka DOLEVA: ", 10, 130, makecol(80, 80, 80));
	VypisText("Posun kostky doleva", 30, 140, makecol(0, 0, 150));

	VypisText("Sipka DOPRAVA: ", 10, 160, makecol(80, 80, 80));
	VypisText("Posun kostky doprava", 30, 170, makecol(0, 0, 150));

	VypisText("Sipka DOLU: ", 10, 190, makecol(80, 80, 80));
	VypisText("Posun kostky rychleji", 30, 200, makecol(0, 0, 150));

	VypisText("Sipka NAHORU, SPACE,", 10, 220, makecol(80, 80, 80));
	VypisText("ENTER:", 10, 230, makecol(80, 80, 80));
	VypisText("Otoceni kostky", 30, 240, makecol(0, 0, 150));

	VypisText("Escape-Zpet do Menu Hry", 10, 260, makecol(0, 120, 0));

	VypisTextGraficky("Dalsi", 460, 210);

	VypisText("MAX Cozrporation 2002 (c)", 230, 460, makecol(0, 0, 100));

//	VypisTextGraficky("ahoj", 10, 10);

/*	for (i=0;i<36;i++)
	{
		masked_blit(Fonty[i], BB, 0, 0, x, 0, Fonty[i]->w, Fonty[i]->h);
		x += Fonty[i]->w;
	}
*/
}


//---------------------------------------
// Name: MuzePolozit()
// Dest: Rozhoduje o tom jestli se muze kostka na dane misto polozit 1-ano 0-ne
//---------------------------------------
int MuzePolozit(void)
{
	int i, j;

	if ( ( (X + Sirka) > HRACI_POLE_X) || ( (Y + Vyska) > HRACI_POLE_Y) )
		return 0;

	if ( (X<0) || (Y<0) )
		return 0;
	
	for (i=0;i<Vyska;i++)
	{
		for (j=0;j<Sirka;j++)
		{
			if ((Kostky[KteraKostka][Otoceni][i][j] == 1) &&
				(HraciPole[Y + i][X + j] != -1))
			{
				return 0;
			}
	
		}
	}

	return 1;
}

//---------------------------------------
// Name: PolozKostku()
// Dest: polozi kostku do hraciho pole
//---------------------------------------
void PolozKostku(void)
{
	int i, j;

	for (i=0;i<Vyska;i++)
	{
		for (j=0;j<Sirka;j++)
		{
			if (Kostky[KteraKostka][Otoceni][i][j] == 1)
				HraciPole[Y + i][X + j] = Barva;
		}

	}
}

//---------------------------------------
// Name: SmazKostku()
// Dest: Smaze kostku z hraciho pole
//---------------------------------------
void SmazKostku(void)
{
	int i, j;

	for (i=0;i<OldVyska;i++)
	{
		for (j=0;j<OldSirka;j++)
		{
			if (Kostky[OldKteraKostka][OldOtoceni][i][j] == 1)
				HraciPole[OldY + i][OldX + j] = -1;
		}

	}
}

//---------------------------------------
// Name: Tick()
// Dest: Stara se o scenu
//---------------------------------------
void DejDoStary(void)
{
	OldX=X;
	OldY=Y;
	OldOtoceni=Otoceni;
	OldKteraKostka = KteraKostka;
	OldSirka = Sirka;
	OldVyska = Vyska;
	OldBarva = Barva;
}

//---------------------------------------
// Name: NactiJmeno()
// Dest: Nacte jmeno od hrace do tabulky vyhercu
//---------------------------------------
void NactiJmeno(void)
{
	int AktPismeno = 0, Klav = 0;

	strcpy(Jmeno, "");

	Jmeno[0] = '\0';
	Jmeno[10] = '\0';

	while (1)
	{
		clear(BB);
		// tady bude jeste dvojtecka za ti Jmeno
		VypisTextGraficky("Zadej jmeno:", 160, 230);

		VypisTextGraficky(Jmeno, 350, 230);
		FlipToScreen();

		Klav = readkey() >> 8;

		if (Klav == KEY_BACKSPACE && AktPismeno > 0)
		{
			AktPismeno--;
			Jmeno[AktPismeno] = ' ';
		}
			

		if ((Klav >= KEY_A) && (Klav <= KEY_Z))     
		{
			Jmeno[AktPismeno] = Klav + 64;
			AktPismeno++;
		}

		if (AktPismeno >= 10)
		{
			AktPismeno = 10;
			Jmeno[AktPismeno] = ' ';
		}

		if (key[KEY_ENTER])
			break;
	}



}

//---------------------------------------
// Name: PorovnejScore()
// Dest: Porovnava score a pripadne updatuje
//---------------------------------------
void PorovnejScore(void)
{
	int i, VemJmeno = 1;

	for (i=0;i<5;i++)
	{
		if (Score > Nejlepsi[i].Score) 
		{
			if (VemJmeno == 1)
			{
				NactiJmeno();
				VemJmeno = 0;
			}
			
			if (i!=4)
			{
				Nejlepsi[i+1].Score = Nejlepsi[i].Score;
				strcpy(Nejlepsi[i+1].Jmeno, Nejlepsi[i].Jmeno);

				Nejlepsi[i].Score = Score;
				strcpy(Nejlepsi[i].Jmeno, Jmeno); 
			}
			else
			{
				Nejlepsi[i].Score = Score;
				strcpy(Nejlepsi[i].Jmeno, Jmeno);
			}


			break;
		}
	}
	
}

//---------------------------------------
// Name: NejlepsiHraci()
// Dest: Ukaze tabulku nebo zapise = 1 - upgraduje score
//---------------------------------------
void NejlepsiHraci(int Zapis)
{
	FILE *f;
	int i;
	char s[128];

	strcpy(s, "");
	clear(screen);

	for (i=0;i<5;i++)
	{
		strcpy(Nejlepsi[i].Jmeno, "");
		Nejlepsi[i].Score = 0;
	}
	
	if (!Zapis)
	{
		if (!(f = fopen("best.dat", "rb")))
		{
			f = fopen("best.dat", "wb");

			if (!f)
				Chyba("Chyba pri vytvoreni souboru!");

			for (i=0;i<5;i++)
			{
				strcpy(Nejlepsi[i].Jmeno, "Beta");
				Nejlepsi[i].Score = 5000 - i * 1000;
			}
			i = fwrite(&Nejlepsi, sizeof(NEJLEPSI), 5, f);
			if (i != 5)
				Chyba("ZAPIS");

			fclose(f);			
		}
		else
		{
			i = fread(&Nejlepsi, sizeof(NEJLEPSI), 5, f);			
			if (i != 5)
				Chyba("CTENI");

			fclose(f);			
		}
	}

	if (Zapis)
	{
		if (!(f = fopen("best.dat", "rb+")))
		{
			f = fopen("best.dat", "wb");

			if (!f)
				Chyba("Chyba pri vytvoreni souboru!");

			for (i=0;i<5;i++)
			{
				strcpy(Nejlepsi[i].Jmeno, "Beta");
				Nejlepsi[i].Score = 5000 - i * 1000;
			}

			PorovnejScore();

			i = fwrite(&Nejlepsi, sizeof(NEJLEPSI), 5, f);
			if (i != 5)
				Chyba("ZAPIS");

			fclose(f);			
		}
		else
		{
			i = fread(&Nejlepsi, sizeof(NEJLEPSI), 5, f);			
			if (i != 5)
				Chyba("CTENI");

			PorovnejScore();

			fseek(f, 0, SEEK_SET);

			i = fwrite(&Nejlepsi, sizeof(NEJLEPSI), 5, f);
			if (i != 5)
				Chyba("ZAPIS");

			fclose(f);			
		}

	}

	clear(BB);

	VypisTextGraficky("Tabulka nejlepsich hracu.", 200, 0);
	
	for (i=0;i<5;i++)
	{
		sprintf(s, "%s", Nejlepsi[i].Jmeno);
		VypisTextGraficky(s, 200, (20*i+150));
		sprintf(s, "%d", Nejlepsi[i].Score);
		VypisTextGraficky(s, 400, (20*i+150));
	}
	VypisTextGraficky("Stiskni cokoliv pro navrat do menu.", 150, 450);

	FlipToScreen();
	clear_keybuf();

	readkey();
}

//---------------------------------------
// Name: KonecHry()
// Dest: Postara se o napsani konec hry a o tabulku vyhercu, aby se uploadla
//---------------------------------------
void KonecHry()
{
	text_mode(-1);
	textprintf_centre(BB, font, SCREEN_W/2, SCREEN_H/2, makecol(255, 0, 0), "Konec!");
	FlipToScreen();

	rest(1000);

	// tady bude 1
	NejlepsiHraci(1);

	// tady to zapise vysledek a takovy ty blbosti ohledne konce hry
	
	//	CekejNaStiskESC();

	
	//	KonecProgramu();
}

//---------------------------------------
// Name: KonecHryEsc()
// Dest: Postara se o napsani konec hry a o tabulku vyhercu, aby se uploadla
//---------------------------------------
int KonecHryEsc()
{
	text_mode(-1);
	textprintf_centre(BB, font, SCREEN_W/2, SCREEN_H/2, makecol(255, 255, 255), "Konec A/N!");
	FlipToScreen();

	while (1)
	{
//		if (MP3Play == TRUE)
//			poll_mp3_file(MP3File);

		if (key[KEY_A])
			return 1;

		if (key[KEY_N])
			return 0;
	}
	clear_keybuf();
	rest(250);
}

//---------------------------------------
// Name: DalsiKostka()
// Dest: vygeneruje dalsi kostku
//---------------------------------------
void DalsiKostka(void)
{
	DalsiOtoceni = RandomInt(4);
	DalsiKteraKostka = RandomInt(6);
	DalsiBarva = RandomInt(7);

	RozmeryKostky(&DalsiSirka, &DalsiVyska, DalsiKteraKostka, DalsiOtoceni);
}




//---------------------------------------
// Name: Tick()
// Dest: Stara se o scenu
//---------------------------------------
void Tick(void)
{
	if (Score>LevelUp)
	{
		NormalniRychlost--;
		if (NormalniRychlost<1)
			NormalniRychlost = 1;
		Rychlost = NormalniRychlost;
		LevelUp += 1000;
		Level++;
	}
	
	if (Rychlost == 1)
		Score += 5;
	else
		Score += 1;

	Timer = 0;

	DejDoStary();
		
	Y++;

    SmazKostku();		

	if (!MuzePolozit())
	{
			// tady pada nova kostka, tak se musi nastavit

		Y--;
		PolozKostku();
		
		KontrolujRadky(); // zkotroluje jestli neni zaplnen radek

		X=3;
		Y=0;
			
		Otoceni = DalsiOtoceni;
		KteraKostka = DalsiKteraKostka;
		Sirka = DalsiSirka;
		Vyska = DalsiVyska;
		Barva = DalsiBarva;
		
		OldX=X;
		OldY=Y;
		OldOtoceni=Otoceni;
		OldKteraKostka = KteraKostka;
		OldSirka = Sirka;
		OldVyska = Vyska;
		OldBarva = Barva;

		if (!MuzePolozit())
		{
//			if (MP3Play == TRUE)
//				close_mp3_file(MP3File);

			KonecHry(); 
			
			Konec = 1;
			return;
			
		}

		PolozKostku();
		DalsiKostka();


	}
	else
		PolozKostku();		
}

//---------------------------------------
// Name: Input()
// Dest: Stara se o vstup z klavesnice
//---------------------------------------
void Input(void)
{
	clear_keybuf();
/*	if (!readkey())
		return;
*/
	
	if (key[KEY_LEFT])
		KlavBuf[0] = 1;

//    if ((readkey() >> 8) == KEY_LEFT)     

	if (key[KEY_RIGHT])
		KlavBuf[1] = 1;
		

	if (key[KEY_SPACE] || key[KEY_ENTER] || key[KEY_UP]) 
	{
		if (KlavBuf[2] == 0)
			MuzeOtocit = 1;
	}
	else
		KlavBuf[2] = 0;



	if (KlavBuf[0] == 1 && InputKlav > OldInputKlav)
	{
		KlavBuf[0] = 0;
		Prekreslit = 1;
		
		DejDoStary();
		X--;
		
		SmazKostku();

		if (!MuzePolozit())
			X++;

		PolozKostku();
//		return;
	}
	
	if (KlavBuf[1] == 1 && InputKlav > OldInputKlav)
	{
		KlavBuf[1] = 0;
		Prekreslit = 1;
		
		DejDoStary();
		X++;
		
		SmazKostku();

		if (!MuzePolozit())
			X--;

		PolozKostku();
//		return;
	}

	if (MuzeOtocit == 1)
	{

		KlavBuf[2] = 1;

		MuzeOtocit = 0;

		Prekreslit = 1;
		
		
		DejDoStary();
		Otoceni++;

		if (Otoceni > 3)
			Otoceni = 0;
		
		RozmeryKostky(&Sirka, &Vyska, KteraKostka, Otoceni);

		SmazKostku();

		if (!MuzePolozit())
		{
			Otoceni--;
			
			if (Otoceni < 0)
				Otoceni = 3;

			RozmeryKostky(&Sirka, &Vyska, KteraKostka, Otoceni);
		}

		PolozKostku();
//		return;
	}
	else
	{
//		MuzeOtocit = 1;
	}

	if (key[KEY_DOWN])
	{
		Prekreslit = 1;
		Rychlost=1;
	}
	else
	{
		Prekreslit = 1;
		Rychlost=NormalniRychlost;
	}

	if (InputKlav != OldInputKlav)
	{ 
		OldInputKlav = InputKlav;
	}

	// asi cisti buffer klavesnice - ani nevim jak to funguje
	clear_keybuf();

//	rest(75);
}

//---------------------------------------
// Name: NewGameInit()
// Dest: Inicializuje se nova hra a vsechno se pro ni pripravi
//---------------------------------------
void NewGameInit(void)
{
//	KteraKostka = 0;
//	Otoceni = 0;

	srand( (unsigned)time( NULL ) );

	KteraKostka = RandomInt(6);
	Otoceni = RandomInt(4);

	RozmeryKostky(&Sirka, &Vyska, KteraKostka, Otoceni);
	InitHraciPole();

	Y=0;
	X=3;

	OldY=Y;
	OldX=X;

	OldBarva = Barva = 0;

	MuzeOtocit = 0;

	PolozKostku();

	Timer = 0;
	Score = 0;
	Konec = 0;
	KlavBuf[0] = 0;
	KlavBuf[1] = 0;
	KlavBuf[2] = 0;
	Level = 1;
	LevelUp = LEVELUP;
	InputKlav = 0;
	OldInputKlav = InputKlav;

	DalsiKostka();

	if (MP3Play == TRUE)
	{
	/*    if ((MP3File = open_mp3_file(PathMP3File)) != NULL)
		{
			if (play_mp3_file(MP3File, BUFSZ, 255, 128) != ALMP3_OK)
				Chyba("MP3");
		}
		else
		{
			MP3Play = FALSE;
//			strcpy(PathMP3File,"./data/sounds/hudba.mp3");
//			if ((MP3File = open_mp3_file(PathMP3File)) != NULL)
//			{
//				if (play_mp3_file(MP3File, BUFSZ, 255, 128) != ALMP3_OK)
//					Chyba("MP3");
//			}
//			else
//				MP3Play = FALSE;
		}
*/
	}
}


//---------------------------------------
// Name: SmazRadu()
// Dest: Smaze radu a nezapomene posunout ty zbyli rady dolu
//---------------------------------------
void SmazRadu(int KteraRada)
{
	int i, j;

	// maze radu
	for (j=0;j<HRACI_POLE_X;j++)
		HraciPole[KteraRada][j] = -1;

	// posouva radky smerem dolu ( to by se dalo cekat ;-) )
	for (i=KteraRada;i>0;i--)
	{
		for (j=0;j<HRACI_POLE_X;j++)
		{
			HraciPole[i][j] = HraciPole[i-1][j];

		}
	}

}

//---------------------------------------
// Name: KontrolujRadky()
// Dest: Kontroluje radky a updatuje score a dela posun
//---------------------------------------
void KontrolujRadky(void)
{
	int i, j, JeCelaRadka = 0;

	for (i=0;i<HRACI_POLE_Y;i++)
	{
		for(j=0;j<HRACI_POLE_X;j++)
		{
			if (HraciPole[i][j] != -1)
				JeCelaRadka++;
		}

		if (JeCelaRadka == 10)
		{
	 		if (HUDBA == TRUE)
				play_sample(snRada, zvVolume, 128, zvRychlost, FALSE);
			Score += 500;
			SmazRadu(i);
			RenderScene();
			text_mode(-1);
			VypisText("Mas Radu!", 280, 200, makecol(255, 255, 0));
			VypisText("Score +500", 280, 210, makecol(255, 255, 0));
			FlipToScreen();
//	 		if (MP3Play == TRUE)
//				poll_mp3_file(MP3File);
			rest(500);
			Timer = 0;
		}

		JeCelaRadka = 0;
	}
}

//---------------------------------------
// Name: CekejNaStiskESC()
// Dest: ceka na stisk ESCape
//---------------------------------------
void CekejNaStiskESC(void)
{
	while(1)
		if (key[KEY_ESC])
			break;
}

//---------------------------------------
// Name: KonecProgramu()
// Dest: Okamzite ukonci program
//---------------------------------------
void KonecProgramu(void)
{
	Chyba("Zadna!");
}

//---------------------------------------
// Name: KresliMenuPolozky()
// Dest: Nakresli menu polozky
//---------------------------------------
void KresliMenuPolozky(void)
{
	int i;

	for(i=0;i<5;i++) 
	{
		masked_blit(MenuPolozky[i], BB, 0, 0, (SCREEN_W - MenuPolozky[i]->w) / 2, 
					((SCREEN_H - 5*MenuPolozky[i]->h) / 2)+ i * MenuPolozky[i]->h, 
					MenuPolozky[i]->w, MenuPolozky[i]->h);
	}

	if (!HUDBA)
	{
		i=1;
		masked_blit(MenuPolozky[5], BB, 0, 0, (SCREEN_W - MenuPolozky[5]->w) / 2, 
					((SCREEN_H - 5*MenuPolozky[5]->h) / 2)+ i * MenuPolozky[5]->h, 
					MenuPolozky[5]->w, MenuPolozky[5]->h);
	}

	FlipToScreen();
}

//---------------------------------------
// Name: KresliMenuPolozky()
// Dest: Nakresli kouli vedle polozky v menu
//---------------------------------------
void KresliKouli(int MA, int OldMA)
{
	masked_blit(Koule[0], BB, 0, 0, 150, MA * 60 + 90, Koule[0]->w, Koule[0]->h);
	masked_blit(Koule[0], BB, 0, 0, 430, MA * 60 + 90, Koule[0]->w, Koule[0]->h);
}

//---------------------------------------
// Name: RenderMenu()
// Dest: Vykresli menu hry
//---------------------------------------
void RenderMenu(void)
{
	clear(BB);

	KresliMenuPolozky();
	KresliKouli(MenuAktive, OldMenuAktive);
	
// DEBUG CODE
/*
	if (MP3Play == TRUE)
		VypisText("MP3Play == TRUE", 100, 150, makecol(255, 0, 0));
	else
		VypisText("MP3Play == FALSE", 100, 150, makecol(255, 0, 0));
	
	if (HUDBA == TRUE)
		VypisText("HUDBA == TRUE", 100, 170, makecol(255, 0, 0));
	else
		VypisText("HUDBA == FALSE", 100, 170, makecol(255, 0, 0));
*/
	FlipToScreen();
}

//---------------------------------------
// Name: PlayGame()
// Dest: Hraje tetris
//---------------------------------------
void PlayGame(void)
{
	NewGameInit();
	
	while (Konec == 0) // 0-hraje 1-game over 2-hrac vyskocil 3-zatim nic
	{
/* 		if (MP3Play == TRUE)
			if (poll_mp3_file(MP3File) != ALMP3_OK)
			{
				close_mp3_file(MP3File);
			    if ((MP3File = open_mp3_file(PathMP3File)) != NULL)
				{
					if (play_mp3_file(MP3File, BUFSZ, 255, 128) != ALMP3_OK)
						Chyba("MP3");
				}
				else
					MP3Play = FALSE;
			}
*/	
		Input(); // vstup z klavesnice

		if (Timer > Rychlost) // posunuti kostky dolu
		{
			Tick();
			Prekreslit = 1;
			if (Konec != 0)
				continue;
		}

		if (Prekreslit) // kresli scenu
		{
  			RenderScene();	

			// a nakonec to vsechno hodi na obrazovku
			FlipToScreen();

			Prekreslit = 0;
		}

//		textprintf(screen, font, 10, 10, makecol(255, 0, 0), "%d", sizeof(NEJLEPSI));

		if (key[KEY_ESC] && Konec == 0) // ukonci hru
		{

			if (KonecHryEsc())
			{
//  		 		if (MP3Play == TRUE)
//					close_mp3_file(MP3File);
				Konec = 2;	 // hrac vyskocil
				NejlepsiHraci(1);
				rest(300);
			}
			clear_keybuf();
		}
	}
}

//---------------------------------------
// Name: Efekt()
// Dest: Efekt pri zmene obrazovky
//---------------------------------------
void Efekt(void)
{
	int i;

	for (i=0;i<320;i++)
	{
		vline(screen,i , 0, SCREEN_H, makecol(50+i/2,50+i/2,50+i/2));
		vline(screen, SCREEN_W-i , 0, SCREEN_H, makecol(50+i/2,50+i/2,50+i/2));
		rest(5);
	}

}

//---------------------------------------
// Name: Autors()
// Dest: Vypise autory hry
//---------------------------------------
void Autors(void)
{
	int i = 0,j=0,k=0,Celkem = 480, y=22;
/*	
	if (MP3Play == TRUE)
	{
	    if ((MP3File = open_mp3_file(PathMP3File)) != NULL)
		{
			if (play_mp3_file(MP3File, BUFSZ, 255, 128) != ALMP3_OK)
				Chyba("MP3");
		}
		else
			MP3Play = FALSE;
	}
*/
	clear(BB);
	FlipToScreen();
	rest(200);
	
// udelat tady vypsani na obrazovku autoru

	clear_keybuf();

	while (1)
	{
// 		if (MP3Play == TRUE)
//			poll_mp3_file(MP3File);

		clear(BB);
		
		Celkem-=2;


		for (j=0;j<49;j++)
		  VypisTextGraficky(szAutors[j], 180, Celkem+j*y);
		
		FlipToScreen();	

		rest(25);

		if (Celkem < -1100)
			break;

		if (keypressed())
			break;
	}

	clear_keybuf();

//	if (MP3Play == TRUE)
//		close_mp3_file(MP3File);
			
//	readkey();
}


void Intro(void)
{
	char szIntroText[48] = "MAX Corporation uvadi";
	char Znak[48];
	int i=0, j;

// tady dat obrazek kterej na strankach



	while (szIntroText[i] != '\0')
	{
		if (HUDBA == TRUE)
			play_sample(snRada, zvVolume, 128, zvRychlost*2, TRUE);

		clear(BB);

		for (j=0;j<=i;j++)
		{
			Znak[j] = szIntroText[j];

		}
		Znak[i+1] = '\0';
		VypisTextGraficky(Znak, 150, 200);
		rest(100); // jako delay
		i++;

		FlipToScreen();
	}
	if (HUDBA == TRUE)
		stop_sample(snRada);
	
	rest(500);

	VypisTextGraficky("KOSTKY", 270, 250);
	FlipToScreen();
	if (HUDBA == TRUE)
		play_sample(snRada, zvVolume, 128, zvRychlost, FALSE);

	rest(500);
	clear(BB);
	FlipToScreen();
	Anim();	

}

//---------------------------------------
// Name: main()
// Dest: hlavni funkce programu
//---------------------------------------
int main(int argc, char *argv[])
//int main(void)
{
	int  Result;
// potreba pro ladeni o nekolik radku dole
//  char s[32];
	int oldMP3Play;


    MP3Play = FALSE;
	HUDBA = TRUE;

	if (argc == 2)
	{
		if (strstr(argv[1], ".mp3"))
		{
			strcpy(PathMP3File, argv[1]);
		    MP3Play = TRUE;

		}
		else 
		{
			if ((strcmp(argv[1], "NOSOUND") == 0) || (strcmp(argv[1], "nosound") == 0))
			{
				MP3Play = FALSE;
				HUDBA = FALSE;
				SOUND = FALSE;
			}
		}
	}


	oldMP3Play = MP3Play;	
//	rest(2000);
	
	Result = InitGame();
	if (Result != 1)
	{
		UnInitGame();
		return 0;
	}

		
// ladici vypis kvuli zvuku
/*
	if (argc == 2)
	{
		strcpy(s, argv[1]);
		s[31] = '\0';
		VypisText(s, 100, 100, makecol(255, 0, 0));
		if (MP3Play)
			VypisText("TRUE", 100, 150, makecol(255, 0, 0));
		else
			VypisText("FALSE", 100, 150, makecol(255, 0, 0));

		FlipToScreen();
		rest(1000);
	}
*/


	
	// to pak zase nechat v pohode
	Intro();

	while (Exit == 0)
	{
		if (MenuAktive != OldMenuAktive) 
		{
			OldMenuAktive = MenuAktive;
			RenderMenu();
			rest(150);
		}

		if (key[KEY_UP])
		{ 
			OldMenuAktive = MenuAktive;
			MenuAktive--;
			if (MenuAktive<0)
				MenuAktive = 4;
		}

		if (key[KEY_DOWN])
		{ 
			OldMenuAktive = MenuAktive;
			MenuAktive++;
			if (MenuAktive>4)
				MenuAktive = 0;
		}

		if (key[KEY_ESC]) 
		{
			Exit = 1;
			continue;
		}	

		if (key[KEY_ENTER])
		{
			if (MenuAktive == 4) 
			{
				Exit = 1;
				continue;
			}

			if (MenuAktive == 3)
			{
				Autors();
				rest(250);
				clear_keybuf();
				OldMenuAktive = MenuAktive + 1 ;
			}
			
			if (MenuAktive == 2)
			{
				NejlepsiHraci(0);
				rest(250);
				clear_keybuf();
				OldMenuAktive = MenuAktive + 1 ;

			}

			if (MenuAktive == 1)
			{
				if (SOUND == TRUE)
				{
				
//				MP3Play = (MP3Play == TRUE) ? FALSE : TRUE ;

					HUDBA = (HUDBA == TRUE) ? FALSE : TRUE;

					if (HUDBA == TRUE && oldMP3Play == TRUE)
						MP3Play = TRUE;
					else
						MP3Play = FALSE;

					if (HUDBA == TRUE)
						play_sample(snRada, zvVolume, 128, zvRychlost, FALSE);

				
//					MP3Play = TRUE;
//				else
//					MP3Play = FALSE;
				
					rest(250);

					OldMenuAktive = MenuAktive + 1 ;
				}
			}

			if (MenuAktive == 0)
			{
				rest(200);
				Efekt();
				PlayGame();
				MenuAktive = 0;
				RenderMenu();
				OldMenuAktive = MenuAktive + 1 ;
			}

		}
}

	
	UnInitGame();

    return 0;
}
END_OF_MAIN();
